/*
 * 
 *  dynamic linker command file
 *  generated: Tue Jul 17 00:23:46 2001

 *  kernel   : legOS
 *  app start: 0xa452
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2452
  ram   : o = 0xa452, l = 0x5aaa
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d4 ;
    _mm_update_first_free = 0x0104 ;
    _mm_init = 0x012a ;
    _malloc = 0x01b0 ;
    _free = 0x0256 ;
    _calloc = 0x0280 ;
    _mm_reaper = 0x02a8 ;
    _systime_handler = 0x0304 ;
    _systime_tm_return = 0x03a0 ;
    _systime_init = 0x03b0 ;
    _systime_shutdown = 0x03fa ;
    _systime_set_switcher = 0x0402 ;
    _systime_set_timeslice = 0x0408 ;
    _tm_switcher = 0x041e ;
    _tm_scheduler = 0x043a ;
    _yield = 0x05fc ;
    _tm_init = 0x061a ;
    _tm_start = 0x065c ;
    _execi = 0x066c ;
    _exit = 0x080c ;
    _wait_event = 0x082e ;
    _msleep = 0x0896 ;
    _sleep = 0x08b8 ;
    _kill = 0x08d6 ;
    _killall = 0x0912 ;
    _sem_event_wait = 0x097a ;
    _sem_wait = 0x0992 ;
    _sem_trywait = 0x09b2 ;
    _sem_post = 0x09ca ;
    _delay = 0x09da ;
    _cputc_native = 0x09fa ;
    _cputc_native_0 = 0x0a28 ;
    _cputc_native_1 = 0x0a5c ;
    _cputc_native_2 = 0x0a92 ;
    _cputc_native_3 = 0x0acc ;
    _cputc_native_4 = 0x0b08 ;
    _cputc_native_5 = 0x0b44 ;
    _cputw = 0x0b50 ;
    _cputs = 0x0b94 ;
    _cls = 0x0bdc ;
    _lcd_number = 0x0be4 ;
    _lcd_refresh_next_byte = 0x0c84 ;
    _lcd_refresh_next_byte_core = 0x0c98 ;
    _lcd_refresh = 0x0ce8 ;
    _lcd_power_on = 0x0d18 ;
    _lcd_power_off = 0x0d2a ;
    _lcd_init = 0x0d46 ;
    _rx_handler = 0x0d90 ;
    _rx_core = 0x0da4 ;
    _rxerror_handler = 0x0e10 ;
    _rxerror_core = 0x0e24 ;
    _txend_handler = 0x0e6a ;
    _txend_core = 0x0e7e ;
    _tx_handler = 0x0e8c ;
    _tx_core = 0x0ea0 ;
    _lnp_logical_shutdown = 0x0ec8 ;
    _lnp_logical_init = 0x0ee8 ;
    _lnp_logical_write = 0x0f9a ;
    _lnp_integrity_write = 0x104a ;
    _lnp_addressing_write = 0x10a2 ;
    _lnp_receive_packet = 0x111c ;
    _lnp_integrity_byte = 0x11a8 ;
    _lnp_integrity_reset = 0x1260 ;
    _lnp_integrity_reset_core = 0x1274 ;
    _lnp_timeout_reset = 0x12a0 ;
    _lnp_timeout_reset_core = 0x12b4 ;
    _lnp_init = 0x12be ;
    _lnp_integrity_active = 0x12d8 ;
    _lnp_timeout_set = 0x12e4 ;
    _program_valid = 0x12ee ;
    _key_handler = 0x1638 ;
    _program_init = 0x173a ;
    _program_shutdown = 0x1780 ;
    _vis_handler = 0x178a ;
    _vis_core = 0x179e ;
    _get_battery_mv = 0x17f6 ;
    _battery_refresh = 0x1820 ;
    _battery_refresh_core = 0x1834 ;
    _shutoff_restart = 0x185a ;
    _shutoff_init = 0x186a ;
    _autoshutoff_check = 0x1876 ;
    _autoshutoff_check_core = 0x188a ;
    _dkey_handler = 0x18ba ;
    _dkey_pressed = 0x18f8 ;
    _dkey_released = 0x191a ;
    _getchar = 0x193a ;
    _dm_handler = 0x1964 ;
    _dm_init = 0x19a2 ;
    _dm_shutdown = 0x19a6 ;
    _motor_a_dir = 0x19ca ;
    _motor_b_dir = 0x1a08 ;
    _motor_c_dir = 0x1a4a ;
    _ds_rotation_set = 0x1a8a ;
    _ds_rotation_handler = 0x1ade ;
    _ds_init = 0x1bce ;
    _ds_shutdown = 0x1c04 ;
    _dsound_handler = 0x1c1c ;
    _dsound_core = 0x1c30 ;
    _dsound_init = 0x1d28 ;
    _dsound_shutdown = 0x1d40 ;
    _dsound_stop = 0x1d44 ;
    _dsound_finished = 0x1d64 ;
    _memset = 0x1d7e ;
    _memcpy = 0x1d8c ;
    ___mulhi3 = 0x1d9e ;
    ___mulsi3 = 0x1dae ;
    ___divsi3 = 0x1dca ;
    _hex_display_codes = 0x1e08 ;
    _ascii_display_codes = 0x1e18 ;
    _min_length = 0x1eaa ;
    _dm_a_pattern = 0x1ebc ;
    _dm_b_pattern = 0x1ec0 ;
    _dm_c_pattern = 0x1ec4 ;
    _firmware_string = 0x1fa6 ;
    _etext = 0x1fa6 ;
    _lcd_refresh_period = 0x1faa ;
    _lnp_timeout = 0x1fac ;
    _vis_refresh_counter = 0x1fae ;
    _vis_refresh_period = 0x1faf ;
    _battery_refresh_counter = 0x1fb0 ;
    _battery_refresh_period = 0x1fb2 ;
    _auto_shutoff_counter = 0x1fb4 ;
    _auto_shutoff_period = 0x1fb6 ;
    _auto_shutoff_secs = 0x1fb8 ;
    _auto_shutoff_elapsed = 0x1fba ;
    _idle_powerdown = 0x1fbc ;
    _dsound_system_sounds = 0x1fbe ;
    _bss_start = 0x1fc0 ;
    __edata = 0x1fc0 ;
    _mm_semaphore = 0x23a8 ;
    _mm_first_free = 0x23aa ;
    _tm_timeslice = 0x23ac ;
    _tm_current_slice = 0x23ad ;
    _tm_switcher_vector = 0x23ae ;
    _sys_time = 0x23b0 ;
    _pd_idle = 0x23c0 ;
    _cpid = 0x23c2 ;
    _nb_tasks = 0x23c4 ;
    _priority_head = 0x23c6 ;
    _pd_single = 0x23d0 ;
    _task_sem = 0x23e4 ;
    _lcd_byte_counter = 0x23e6 ;
    _lcd_refresh_counter = 0x23e7 ;
    _tx_state = 0x23e8 ;
    _tx_sem = 0x23e9 ;
    _lnp_integrity_handler = 0x23f0 ;
    _lnp_timeout_counter = 0x23f2 ;
    _lnp_addressing_handler = 0x2400 ;
    _lnp_integrity_state = 0x2420 ;
    _packet_len = 0x2422 ;
    _cprog = 0x2424 ;
    _packet_src = 0x2426 ;
    _dkey_timer = 0x2428 ;
    _dkey = 0x2429 ;
    _dkey_multi = 0x242a ;
    _dm_a = 0x242c ;
    _dm_b = 0x2430 ;
    _dm_c = 0x2434 ;
    _ds_rotation = 0x2438 ;
    _ds_channel = 0x2439 ;
    _ds_rotations = 0x243c ;
    _ds_activation = 0x2442 ;
    _dsound_next_note = 0x2444 ;
    _dsound_internote_ms = 0x2446 ;
    _dsound_16th_ms = 0x2448 ;
    _dsound_next_time = 0x244c ;
    _end = 0x2450 ;
    _mm_start = 0x2450 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
