/*
 * 
 *  dynamic linker command file
 *  generated: Tue Oct 31 00:46:29 2000

 *  kernel   : legOS
 *  app start: 0xa4c6
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x24c6
  ram   : o = 0xa4c6, l = 0x5a36
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d4 ;
    _mm_update_first_free = 0x0104 ;
    _mm_init = 0x0126 ;
    _malloc = 0x01ac ;
    _free = 0x0250 ;
    _calloc = 0x027a ;
    _mm_reaper = 0x02a2 ;
    _systime_handler = 0x02fe ;
    _systime_tm_return = 0x039a ;
    _systime_init = 0x03aa ;
    _systime_shutdown = 0x03f4 ;
    _systime_set_switcher = 0x03fc ;
    _systime_set_timeslice = 0x0402 ;
    _tm_switcher = 0x0418 ;
    _tm_scheduler = 0x0434 ;
    _yield = 0x0628 ;
    _tm_init = 0x0646 ;
    _tm_start = 0x0688 ;
    _execi = 0x0698 ;
    _exit = 0x082c ;
    _wait_event = 0x084e ;
    _msleep = 0x08ba ;
    _sleep = 0x08dc ;
    _kill = 0x08fa ;
    _killall = 0x0936 ;
    _sem_event_wait = 0x09a4 ;
    _sem_wait = 0x09bc ;
    _sem_trywait = 0x09dc ;
    _sem_post = 0x09f4 ;
    _delay = 0x0a04 ;
    _cputc_native = 0x0a1e ;
    _cputc_native_0 = 0x0a50 ;
    _cputc_native_1 = 0x0a88 ;
    _cputc_native_2 = 0x0ac0 ;
    _cputc_native_3 = 0x0afc ;
    _cputc_native_4 = 0x0b38 ;
    _cputc_native_5 = 0x0b74 ;
    _cputw = 0x0b80 ;
    _cputs = 0x0bc4 ;
    _cls = 0x0c0c ;
    _lcd_number = 0x0c16 ;
    _lcd_refresh_next_byte = 0x0ca8 ;
    _lcd_refresh_next_byte_core = 0x0cbc ;
    _lcd_refresh = 0x0d10 ;
    _lcd_power_on = 0x0d40 ;
    _lcd_power_off = 0x0d52 ;
    _lcd_init = 0x0d6e ;
    _rx_handler = 0x0db6 ;
    _rx_core = 0x0dca ;
    _rxerror_handler = 0x0e40 ;
    _rxerror_core = 0x0e54 ;
    _txend_handler = 0x0e9e ;
    _txend_core = 0x0eb2 ;
    _tx_handler = 0x0ec0 ;
    _tx_core = 0x0ed4 ;
    _lnp_logical_shutdown = 0x0efc ;
    _lnp_logical_init = 0x0f1c ;
    _lnp_logical_write = 0x0fca ;
    _lnp_integrity_write = 0x107a ;
    _lnp_addressing_write = 0x10d2 ;
    _lnp_receive_packet = 0x114c ;
    _lnp_integrity_byte = 0x11f2 ;
    _lnp_integrity_reset = 0x12b0 ;
    _lnp_integrity_reset_core = 0x12c4 ;
    _lnp_timeout_reset = 0x12f0 ;
    _lnp_timeout_reset_core = 0x1304 ;
    _lnp_init = 0x130e ;
    _lnp_integrity_active = 0x132e ;
    _lnp_timeout_set = 0x133a ;
    _program_valid = 0x1344 ;
    _key_handler = 0x1688 ;
    _program_init = 0x1788 ;
    _program_shutdown = 0x17ce ;
    _vis_handler = 0x17d8 ;
    _vis_core = 0x17ec ;
    _get_battery_mv = 0x1840 ;
    _battery_refresh = 0x186e ;
    _battery_refresh_core = 0x1882 ;
    _shutoff_restart = 0x18ac ;
    _shutoff_init = 0x18bc ;
    _autoshutoff_check = 0x18c8 ;
    _autoshutoff_check_core = 0x18dc ;
    _dkey_handler = 0x190e ;
    _dkey_pressed = 0x194c ;
    _dkey_released = 0x196e ;
    _getchar = 0x198e ;
    _dm_handler = 0x19b8 ;
    _dm_init = 0x19f6 ;
    _dm_shutdown = 0x19fa ;
    _motor_a_dir = 0x1a1e ;
    _motor_b_dir = 0x1a5e ;
    _motor_c_dir = 0x1aa2 ;
    _ds_rotation_set = 0x1aea ;
    _ds_rotation_handler = 0x1b42 ;
    _ds_init = 0x1c36 ;
    _ds_shutdown = 0x1c6c ;
    _dsound_handler = 0x1c86 ;
    _dsound_core = 0x1c9a ;
    _dsound_init = 0x1d94 ;
    _dsound_shutdown = 0x1dac ;
    _dsound_stop = 0x1db0 ;
    _dsound_finished = 0x1dd0 ;
    _memset = 0x1dea ;
    _memcpy = 0x1df8 ;
    ___mulhi3 = 0x1e0a ;
    ___mulsi3 = 0x1e1a ;
    ___divsi3 = 0x1e36 ;
    _hex_display_codes = 0x1e74 ;
    _ascii_display_codes = 0x1e84 ;
    _min_length = 0x1f16 ;
    _dm_a_pattern = 0x1f28 ;
    _dm_b_pattern = 0x1f2c ;
    _dm_c_pattern = 0x1f30 ;
    _firmware_string = 0x2012 ;
    _etext = 0x2012 ;
    _lcd_refresh_period = 0x2016 ;
    _lnp_timeout = 0x2018 ;
    _vis_refresh_counter = 0x201a ;
    _vis_refresh_period = 0x201b ;
    _battery_refresh_counter = 0x201c ;
    _battery_refresh_period = 0x201e ;
    _auto_shutoff_counter = 0x2020 ;
    _auto_shutoff_period = 0x2022 ;
    _auto_shutoff_secs = 0x2024 ;
    _auto_shutoff_elapsed = 0x2026 ;
    _idle_powerdown = 0x2028 ;
    _dsound_system_sounds = 0x202a ;
    __edata = 0x202c ;
    _bss_start = 0x2030 ;
    _mm_semaphore = 0x2418 ;
    _mm_first_free = 0x241a ;
    _tm_timeslice = 0x241c ;
    _tm_current_slice = 0x241d ;
    _tm_switcher_vector = 0x241e ;
    _sys_time = 0x2420 ;
    _pd_idle = 0x2430 ;
    _cpid = 0x2432 ;
    _nb_tasks = 0x2434 ;
    _priority_head = 0x2436 ;
    _pd_single = 0x2440 ;
    _task_sem = 0x2454 ;
    _lcd_byte_counter = 0x2456 ;
    _lcd_refresh_counter = 0x2457 ;
    _tx_state = 0x2458 ;
    _tx_sem = 0x2459 ;
    _lnp_integrity_handler = 0x2460 ;
    _lnp_timeout_counter = 0x2462 ;
    _lnp_addressing_handler = 0x2470 ;
    _lnp_integrity_state = 0x2490 ;
    _packet_len = 0x2492 ;
    _cprog = 0x2494 ;
    _packet_src = 0x2496 ;
    _dkey_timer = 0x2498 ;
    _dkey = 0x2499 ;
    _dkey_multi = 0x249a ;
    _dm_a = 0x249c ;
    _dm_b = 0x24a0 ;
    _dm_c = 0x24a4 ;
    _ds_rotation = 0x24a8 ;
    _ds_channel = 0x24a9 ;
    _ds_rotations = 0x24b0 ;
    _ds_activation = 0x24b6 ;
    _dsound_next_note = 0x24b8 ;
    _dsound_internote_ms = 0x24ba ;
    _dsound_16th_ms = 0x24bc ;
    _dsound_next_time = 0x24c0 ;
    _end = 0x24c4 ;
    _mm_start = 0x24c4 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
